use crate::paths::get_exec_prefix;
use std::path::PathBuf;

pub const APP_NAME: &str = "Envision";
pub const APP_ID: &str = "org.gabmus.envision";
pub const RESOURCES_BASE_PATH: &str = "/org/gabmus/envision";
pub const PKG_DATA_DIR: &str = "/usr/share/envision";
pub const RESOURCES: &str = concat!("/usr/share/envision", "/resources.gresource");
pub const CMD_NAME: &str = "envision";
pub const VERSION: &str = "3.0.1";
pub const REPO_URL: &str = "https://gitlab.com/gabmus/envision";
pub const ISSUES_URL: &str = "https://gitlab.com/gabmus/envision/-/issues";
pub const SINGLE_DEVELOPER: &str = "The Envision Team";
pub const GETTEXT_PACKAGE: &str = "envision";
pub const LOCALE_DIR: &str = "/usr/share/locale";
pub const BUILD_PROFILE: &str = "";
pub const BUILD_DATETIME: &str = "2025-03-06T19:38:44+00:00";

pub fn get_artists() -> Vec<String> {
    vec!["App Icon: Yannick (@Yandr)".into()]
}

pub fn pkg_data_dir() -> PathBuf {
    get_exec_prefix().join("share").join(CMD_NAME)
}

pub fn resources() -> String {
    format!("{}/resources.gresource", pkg_data_dir().to_string_lossy())
}
